(************************************************************************)
(*																		*)
(*		Compression of Room Data. Compression should *NOT* apply		*)
(*		to the first 2 bytes of the file.								*)
(*																		*)
(************************************************************************)

unit Compress;

interface

type ByteArray = array[0..255] of Byte;

procedure	CompressData(var Count:Byte;var Data:ByteArray);

implementation

procedure	CompressData(var Count:Byte;var Data:ByteArray);
var OrgSize,NewSize:LongInt;
	i,n,Pos,Bytes:Integer;
begin
	OrgSize := Count;

	Pos := 2;							{ Start 2 in }
	Bytes := Count-2;					{ 2 bytes less to crunch }

	while Bytes > 0 do
		begin
			n := 0; 					{ Count repeating elements }
			while (Bytes-n > 0) and
            			(Data[Pos] = Data[Pos+n]) do Inc(n);

			if n < 4 then				{ at least 4 to compress }
				begin
					Pos := Pos + n;
					Bytes := Bytes - n;
				end
			else
				begin
					Data[Pos] := $C0;	{ Repeat marker }
					Data[Pos+1] := n;	{ Count }
										{ Data (Pos+2) will be the byte }

					Pos := Pos + 3;		{ Skip that }
					Bytes := Bytes - 3;
					n := n - 3;			{ Number of bytes to delete }
					while n > 0 do
						begin
							for i := Pos to 254 do Data[i] := Data[i+1];
							Dec(Bytes);
							Dec(n);
							Dec(Count);
						end;
				end;
        end;

	n := 2; 							{ Verify it expands correctly }
	i := 2;
	while i < Count do
		begin
			if Data[i] = $C0 then
				begin
					n := n + Data[i+1];
                    i := i + 3;
				end
			else
				begin
					Inc(n);Inc(i);
				end;
		end;
	if n <> 255 then					{ well, to the right size :) }
		begin
			WriteLn('Compression has failed');
			Halt(0);
		end;

	NewSize := Count;
	WriteLn('        Compression ',(NewSize*100 div OrgSize),'% of original.');
end;

begin
end.
